searchData={"items":[{"type":"module","title":"MishkaDeveloperTools","doc":"# Mishka Elixir Developer Tools\n\nWe tried to deliver a series of our client's [**CMS**](https://github.com/mishka-group/mishka-cms) built on\n[**Elixir**](https://elixir-lang.org/) at the start of the [**Mishka Group**](https://github.com/mishka-group) project,\nbut we recently archived this open-source project and have yet to make plans to rework and expand it.\nThis system was created using [**Phoenix**](https://www.phoenixframework.org/) and\n[**Phoenix LiveView**](https://hexdocs.pm/phoenix_live_view/Phoenix.LiveView.html).\nAfter a long period, a series of macros and functional modules emerged from this\nproject and our other projects, which we are gradually publishing in this library.\n\n> **NOTICE**: Do not use the master branch; this library is under heavy development.\nExpect version `0.1.3`, and for using the new features, please wait until a new release is out.\n---\n\n- #### [GuardedStruct](https://github.com/mishka-group/mishka_developer_tools/blob/master/guidance/guarded-struct.md)\n\n- #### [Basic CRUD](https://github.com/mishka-group/mishka_developer_tools/blob/master/guidance/crud.md)\n\n- #### [PermissionAccess](https://github.com/mishka-group/mishka_developer_tools/blob/master/guidance/permission-access.md)\n---\n\n> Mishka developer tools provides some macros and modules to make creating your elixir application as easy as possible","ref":"MishkaDeveloperTools.html"},{"type":"module","title":"Installation - MishkaDeveloperTools","doc":"The package can be installed by adding `mishka_developer_tools` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:mishka_developer_tools, \"~> 0.1.3\"}\n  ]\nend\n```\n\nThe docs can be found at [https://hexdocs.pm/mishka_developer_tools](https://hexdocs.pm/mishka_developer_tools).","ref":"MishkaDeveloperTools.html#module-installation"},{"type":"behaviour","title":"MishkaDeveloperTools.DB.CRUD","doc":"","ref":"MishkaDeveloperTools.DB.CRUD.html"},{"type":"behaviour","title":"Simplified CRUD macro using Ecto - MishkaDeveloperTools.DB.CRUD","doc":"With this module, you can easily implement CRUD-related items in your file wherever you need to build a query.\nThese modules and their sub-macros were created more to create a one-piece structure, and you can implement your own custom items in umbrella projects.\nIn the first step, to use the following macros, you must bind the requested information in the relevant module that you have already created as follows.\n```elixir\nuse MishkaDeveloperTools.DB.CRUD,\n    module: YOURschemaMODULE,\n    repo: Your.Repo,\n    id: :uuid OR ANY_TYPE_YOU_WANT\n```\nIt should be noted that the following three parameters must be sent and also make sure you are connected to the database.\n\n```elixir\nmodule\nrepo\nid\n```","ref":"MishkaDeveloperTools.DB.CRUD.html#module-simplified-crud-macro-using-ecto"},{"type":"callback","title":"MishkaDeveloperTools.DB.CRUD.create/1","doc":"","ref":"MishkaDeveloperTools.DB.CRUD.html#c:create/1"},{"type":"macro","title":"MishkaDeveloperTools.DB.CRUD.crud_add/1","doc":"#","ref":"MishkaDeveloperTools.DB.CRUD.html#crud_add/1"},{"type":"macro","title":"Creating a record macro - MishkaDeveloperTools.DB.CRUD.crud_add/1","doc":"","ref":"MishkaDeveloperTools.DB.CRUD.html#crud_add/1-creating-a-record-macro"},{"type":"macro","title":"Example - MishkaDeveloperTools.DB.CRUD.crud_add/1","doc":"```elixir\ncrud_add(map_of_info like: %{\"name\" => \"Mishka\"})\n```\nThe input of this macro is a map and its output are a map. For example\n\n```elixir\n{:error, :add, repo_error()}\n{:ok, :add, repo_data()}\n```\n\nIf you want only the selected parameters to be separated from the list of submitted parameters and sent to the database, use the same macro with input 2\n\n###  Example\n```elixir\ncrud_add(map_of_info like: %{\"name\" => \"Mishka\"}, [\"name\"])\n```","ref":"MishkaDeveloperTools.DB.CRUD.html#crud_add/1-example"},{"type":"macro","title":"MishkaDeveloperTools.DB.CRUD.crud_add/2","doc":"","ref":"MishkaDeveloperTools.DB.CRUD.html#crud_add/2"},{"type":"macro","title":"MishkaDeveloperTools.DB.CRUD.crud_delete/1","doc":"#","ref":"MishkaDeveloperTools.DB.CRUD.html#crud_delete/1"},{"type":"macro","title":"delete a record from the database with the help of ID Macro - MishkaDeveloperTools.DB.CRUD.crud_delete/1","doc":"With the help of this macro, you can delete your requested record from the database.\nThe input of this macro is a UUID and its output is a map","ref":"MishkaDeveloperTools.DB.CRUD.html#crud_delete/1-delete-a-record-from-the-database-with-the-help-of-id-macro"},{"type":"macro","title":"Example - MishkaDeveloperTools.DB.CRUD.crud_delete/1","doc":"```elixir\ncrud_delete(\"6d80d5f4-781b-4fa8-9796-1821804de6ba\")\ncrud_delete(\"6d80d5f4-781b-4fa8-9796-1821804de6ba\", [:comment, :post])\n```\nOutput:\nYou should note that this macro prevents the orphan data of the record requested to be deleted. So, use this macro when the other data is not dependent on the data with the ID sent by you.\n\nOutputs:\n\n```elixir\n{:error, :delete, repo_error()}\n{:error, :delete, {:error, :uuid | :not_found | :force_constraint, String.t()}}\n{:ok, :delete, repo_data()}\n```","ref":"MishkaDeveloperTools.DB.CRUD.html#crud_delete/1-example"},{"type":"macro","title":"MishkaDeveloperTools.DB.CRUD.crud_delete/2","doc":"","ref":"MishkaDeveloperTools.DB.CRUD.html#crud_delete/2"},{"type":"macro","title":"MishkaDeveloperTools.DB.CRUD.crud_edit/1","doc":"#","ref":"MishkaDeveloperTools.DB.CRUD.html#crud_edit/1"},{"type":"macro","title":"Edit a record in a database Macro - MishkaDeveloperTools.DB.CRUD.crud_edit/1","doc":"With the help of this macro, you can edit a record in the database with its ID. For this purpose, you must send the requested record ID along with the new Map parameters. Otherwise the macro returns the ID error.","ref":"MishkaDeveloperTools.DB.CRUD.html#crud_edit/1-edit-a-record-in-a-database-macro"},{"type":"macro","title":"Example - MishkaDeveloperTools.DB.CRUD.crud_edit/1","doc":"```elixir\ncrud_edit(map_of_info like: %{\"id\" => \"6d80d5f4-781b-4fa8-9796-1821804de6ba\", \"name\" => \"Mishka\"})\n```\n> Note that the sending ID must be of UUID type.\n\nThe input of this macro is a map and its output are a map. For example\n\n```elixir\n{:error, :edit, repo_error()}\n{:ok, :edit, repo_data()}\n{:error, :edit, {:error, :uuid | :not_found, String.t()}}\n```\n\nIt should be noted that if you want only the selected fields to be separated from the submitted parameters and sent to the database, use the macro with dual input.","ref":"MishkaDeveloperTools.DB.CRUD.html#crud_edit/1-example"},{"type":"macro","title":"Example - MishkaDeveloperTools.DB.CRUD.crud_edit/1","doc":"```elixir\ncrud_edit(map_of_info like: %{\"id\" => \"6d80d5f4-781b-4fa8-9796-1821804de6ba\", \"name\" => \"Mishka\"}, , [\"id\", \"name\"])\n```","ref":"MishkaDeveloperTools.DB.CRUD.html#crud_edit/1-example"},{"type":"macro","title":"MishkaDeveloperTools.DB.CRUD.crud_edit/2","doc":"","ref":"MishkaDeveloperTools.DB.CRUD.html#crud_edit/2"},{"type":"macro","title":"MishkaDeveloperTools.DB.CRUD.crud_get_by_field/2","doc":"#","ref":"MishkaDeveloperTools.DB.CRUD.html#crud_get_by_field/2"},{"type":"macro","title":"Macro Find a record in the database with the help of the requested field - MishkaDeveloperTools.DB.CRUD.crud_get_by_field/2","doc":"With the help of this macro, you can find a field with the value you want, if it exists in the database. It should be noted that the field name must be entered as a String.\n\n\n# Example\n```elixir\ncrud_get_by_field(\"email\", \"info@trangell.com\")\n```\n\nOutputs:\n\n```\n{:error, :not_found, String.t()} | struct()\n```","ref":"MishkaDeveloperTools.DB.CRUD.html#crud_get_by_field/2-macro-find-a-record-in-the-database-with-the-help-of-the-requested-field"},{"type":"macro","title":"MishkaDeveloperTools.DB.CRUD.crud_get_record/1","doc":"#","ref":"MishkaDeveloperTools.DB.CRUD.html#crud_get_record/1"},{"type":"macro","title":"Macro Finding a record in a database with the help of ID - MishkaDeveloperTools.DB.CRUD.crud_get_record/1","doc":"With the help of this macro, you can send an ID that is of UUID type and call it if there is a record in the database.\nThe output of this macro is map.\n\n\n# Example\n```elixir\ncrud_get_record(\"6d80d5f4-781b-4fa8-9796-1821804de6ba\")\n```\n\nOutputs:\n\n```\n{:error, :not_found, String.t()} | struct()\n```","ref":"MishkaDeveloperTools.DB.CRUD.html#crud_get_record/1-macro-finding-a-record-in-a-database-with-the-help-of-id"},{"type":"callback","title":"MishkaDeveloperTools.DB.CRUD.delete/1","doc":"","ref":"MishkaDeveloperTools.DB.CRUD.html#c:delete/1"},{"type":"callback","title":"MishkaDeveloperTools.DB.CRUD.delete/2","doc":"","ref":"MishkaDeveloperTools.DB.CRUD.html#c:delete/2"},{"type":"callback","title":"MishkaDeveloperTools.DB.CRUD.edit/1","doc":"","ref":"MishkaDeveloperTools.DB.CRUD.html#c:edit/1"},{"type":"callback","title":"MishkaDeveloperTools.DB.CRUD.show_by_field/2","doc":"","ref":"MishkaDeveloperTools.DB.CRUD.html#c:show_by_field/2"},{"type":"callback","title":"MishkaDeveloperTools.DB.CRUD.show_by_id/1","doc":"","ref":"MishkaDeveloperTools.DB.CRUD.html#c:show_by_id/1"},{"type":"type","title":"MishkaDeveloperTools.DB.CRUD.record_input/0","doc":"","ref":"MishkaDeveloperTools.DB.CRUD.html#t:record_input/0"},{"type":"type","title":"MishkaDeveloperTools.DB.CRUD.repo_data/0","doc":"","ref":"MishkaDeveloperTools.DB.CRUD.html#t:repo_data/0"},{"type":"type","title":"MishkaDeveloperTools.DB.CRUD.repo_error/0","doc":"","ref":"MishkaDeveloperTools.DB.CRUD.html#t:repo_error/0"},{"type":"module","title":"MishkaDeveloperTools.Helper.Derive","doc":"","ref":"MishkaDeveloperTools.Helper.Derive.html"},{"type":"function","title":"MishkaDeveloperTools.Helper.Derive.derive/1","doc":"","ref":"MishkaDeveloperTools.Helper.Derive.html#derive/1"},{"type":"function","title":"MishkaDeveloperTools.Helper.Derive.derive/2","doc":"","ref":"MishkaDeveloperTools.Helper.Derive.html#derive/2"},{"type":"function","title":"MishkaDeveloperTools.Helper.Derive.error_handler/2","doc":"","ref":"MishkaDeveloperTools.Helper.Derive.html#error_handler/2"},{"type":"module","title":"MishkaDeveloperTools.Helper.Derive.Parser","doc":"","ref":"MishkaDeveloperTools.Helper.Derive.Parser.html"},{"type":"function","title":"MishkaDeveloperTools.Helper.Derive.Parser.convert_parameters/2","doc":"","ref":"MishkaDeveloperTools.Helper.Derive.Parser.html#convert_parameters/2"},{"type":"function","title":"MishkaDeveloperTools.Helper.Derive.Parser.convert_to_atom_map/1","doc":"","ref":"MishkaDeveloperTools.Helper.Derive.Parser.html#convert_to_atom_map/1"},{"type":"function","title":"MishkaDeveloperTools.Helper.Derive.Parser.field_status?/2","doc":"","ref":"MishkaDeveloperTools.Helper.Derive.Parser.html#field_status?/2"},{"type":"function","title":"MishkaDeveloperTools.Helper.Derive.Parser.field_value/1","doc":"","ref":"MishkaDeveloperTools.Helper.Derive.Parser.html#field_value/1"},{"type":"function","title":"MishkaDeveloperTools.Helper.Derive.Parser.parse_core_keys_pattern/1","doc":"","ref":"MishkaDeveloperTools.Helper.Derive.Parser.html#parse_core_keys_pattern/1"},{"type":"function","title":"MishkaDeveloperTools.Helper.Derive.Parser.parser/1","doc":"","ref":"MishkaDeveloperTools.Helper.Derive.Parser.html#parser/1"},{"type":"module","title":"MishkaDeveloperTools.Helper.Derive.SanitizerDerive","doc":"","ref":"MishkaDeveloperTools.Helper.Derive.SanitizerDerive.html"},{"type":"function","title":"MishkaDeveloperTools.Helper.Derive.SanitizerDerive.call/2","doc":"","ref":"MishkaDeveloperTools.Helper.Derive.SanitizerDerive.html#call/2"},{"type":"function","title":"MishkaDeveloperTools.Helper.Derive.SanitizerDerive.sanitize/2","doc":"","ref":"MishkaDeveloperTools.Helper.Derive.SanitizerDerive.html#sanitize/2"},{"type":"function","title":"MishkaDeveloperTools.Helper.Derive.SanitizerDerive.validate_pattern/3","doc":"","ref":"MishkaDeveloperTools.Helper.Derive.SanitizerDerive.html#validate_pattern/3"},{"type":"module","title":"MishkaDeveloperTools.Helper.Derive.ValidationDerive","doc":"","ref":"MishkaDeveloperTools.Helper.Derive.ValidationDerive.html"},{"type":"function","title":"MishkaDeveloperTools.Helper.Derive.ValidationDerive.call/3","doc":"","ref":"MishkaDeveloperTools.Helper.Derive.ValidationDerive.html#call/3"},{"type":"function","title":"MishkaDeveloperTools.Helper.Derive.ValidationDerive.convert_enum/2","doc":"","ref":"MishkaDeveloperTools.Helper.Derive.ValidationDerive.html#convert_enum/2"},{"type":"function","title":"MishkaDeveloperTools.Helper.Derive.ValidationDerive.validate/3","doc":"","ref":"MishkaDeveloperTools.Helper.Derive.ValidationDerive.html#validate/3"},{"type":"module","title":"PermissionAccess","doc":"Consider the scenario in which you are responsible for maintaining each user's access\n  level in the database related to users. In addition, each router in your controller needs\n  to be free for one access while preventing other things from accessing it. To achieve\n  this goal, the PermissionAccess module provides assistance in implementing a Unix-like mode\n  in the most straightforward manner feasible.\n  This module was written with the contribution of Mr. Toomaj Boloorian,\n  who can be found at the following GitHub address: https://github.com/toomaj\n  and and Shahryar Tavakkoli: https://github.com/shahryarjb","ref":"PermissionAccess.html"},{"type":"function","title":"PermissionAccess.is_permitted?/1","doc":"This section is identical to the function known as `permittes?/2`, with the exception that\n it examines only a single user access rather than a list of accesses.\n\n ```elixir\nPermissionAccess.is_permitted?(action: \"*\", @admin_router[\"AdminBlogNotifsLive\"])\n ```","ref":"PermissionAccess.html#is_permitted?/1"},{"type":"function","title":"PermissionAccess.permittes?/2","doc":"#","ref":"PermissionAccess.html#permittes?/2"},{"type":"function","title":"Allow access to the user - PermissionAccess.permittes?/2","doc":"Access in this section is referred to as an action, and in addition, there are two sections included.\n\nThe first portion may grant access to an entire department or to an entire role, whereas the second part\nmay be delegated to a specific part. But this explanation is subject to alter depending on the strategy\nyou choose. Because of this, pay close attention to the instances that follow.\n\nWithin this section, the user has access to all portions of your program thanks to the wildcard permissions that have been granted to him.\n\n**Note**: You have the option of assigning a star `*` rating or writing it as `*:*`.\n\n```elixir\n@admin_router %{\n  # admin router\n  \"AdminDashboardLive\" => \"admin:*\",\n  \"AdminBlogPostsLive\" => \"admin:edit\",\n  \"AdminBlogPostLive\" => \"admin:edit\",\n  \"AdminBlogCategoriesLive\" => \"admin:edit\",\n  \"AdminBlogCategoryLive\" => \"admin:edit\",\n  \"AdminBookmarksLive\" => \"*\",\n  \"AdminSubscriptionsLive\" => \"*\",\n  \"AdminSubscriptionLive\" => \"*\",\n  \"AdminCommentsLive\" => \"admin:edit\",\n  \"AdminCommentLive\" => \"admin:edit\",\n  \"AdminUsersLive\" => \"*\",\n  \"AdminUserLive\" => \"*\",\n  \"AdminLogsLive\" => \"*\",\n  \"AdminSeoLive\" => \"*\",\n  \"AdminBlogPostAuthorsLive\" => \"admin:edit\",\n  \"AdminBlogNotifLive\" => \"*\",\n  \"AdminBlogNotifsLive\" => \"admin:view\"\n}\n\nuser_actions = [%{value: \"*\"}]\nPermissionAccess.permittes?(user_actions, @admin_router[item])\n# This should be true, and the user has access.\n\nuser_actions = [%{value: \"*:edit\"}]\nPermissionAccess.permittes?(user_actions, @admin_router[\"AdminBlogNotifsLive\"])\n# This should be false, and the user has no access.\n\nuser_actions = [%{value: \"*:edit\"}, %{value: \"admin:view\"}]\nPermissionAccess.permittes?(user_actions, @admin_router[\"AdminBlogNotifsLive\"])\n# This should be true, and the user has access.\n```","ref":"PermissionAccess.html#permittes?/2-allow-access-to-the-user"},{"type":"type","title":"PermissionAccess.action/0","doc":"","ref":"PermissionAccess.html#t:action/0"},{"type":"type","title":"PermissionAccess.user_permissions/0","doc":"","ref":"PermissionAccess.html#t:user_permissions/0"},{"type":"exception","title":"GuardedStruct","doc":"The creation of this macro will allow you to build `Structs` that provide you with a number of\nimportant options, including the following:\n\n1. Validation\n2. Sanitizing\n3. Constructor\n4. It provides the capacity to operate in a nested style simultaneously.\n\nSuppose you are going to collect a number of pieces of information from the user,\nand before doing anything else, you are going to sanitize them.\nAfter that, you are going to validate each piece of data, and if there are no issues,\nyou will either display it in a proper output or save it somewhere else.\nAll of the characteristics that are associated with this macro revolve around cleaning and validating the data.\n\nThe features that we list below are individually based on a particular strategy\nand requirement, but thankfully, they may be combined and mixed in any way that you see fit.\n\nIt bestows to you a significant amount of authority in this sphere.\nAfter the initial version of this macro was obtained from the source of the `typed_struct` library,\nmany sections of it were rewritten, or new concepts were taken from libraries in Rust and Scala\nand added to this library in the form of Elixir base.\n\nThe initial version of this macro can be found in the `typed_struct` library. Its base is a\nsyntax that is very easy to comprehend, especially for non-technical product managers, and highly straightforward.\n\nBefore explaining the copyright, I must point out that the primary library, which is `typed_struct`,\nis no longer supported for a long time, so please pay attention to the following copyright.","ref":"GuardedStruct.html"},{"type":"exception","title":"Copyright - GuardedStruct","doc":"The code in this module is based on the `typed_struct` library (https://github.com/ejpcmac/typed_struct),\nwhich is licensed under the MIT License.\n\nModifications and additions have been made to enhance its capabilities as part of the current project.\n\n**MIT License**\n\nAdding new Copyright (c) [2023] [Shahryar Tavakkoli at [Mishka Group](https://github.com/mishka-group)]\n\n**Note:** If the license changes during the support of this project, this file will always remain on MIT","ref":"GuardedStruct.html#module-copyright"},{"type":"macro","title":"GuardedStruct.conditional_field/4","doc":"","ref":"GuardedStruct.html#conditional_field/4"},{"type":"function","title":"GuardedStruct.conditional_fields_validating_pattern/1","doc":"","ref":"GuardedStruct.html#conditional_fields_validating_pattern/1"},{"type":"macro","title":"GuardedStruct.create_error_module/0","doc":"","ref":"GuardedStruct.html#create_error_module/0"},{"type":"function","title":"GuardedStruct.exceptions_handler/3","doc":"","ref":"GuardedStruct.html#exceptions_handler/3"},{"type":"macro","title":"GuardedStruct.guardedstruct/2","doc":"#","ref":"GuardedStruct.html#guardedstruct/2"},{"type":"macro","title":"Defines a guarded struct - GuardedStruct.guardedstruct/2","doc":"The beginning of the block consists of the introduction of a `Struct` with the `guardedstruct` macro,\nwhich is solely responsible for recording a series of information in order to create a struct, as well\nas all of the fields with the `field` macro, and if you need to create another struct within this struct\n(in actuality, a module child within another module), you must use the `sub_field` macro.\n\n**Note:** there is no restriction on the number of times you can call the `sub_field` macro or the\nfield macro within the context of the `sub_field` macro.\n\n**Note:** Because `Stract` does not prioritize the display of keys depending on your requirements,\nyou do not need to follow the priority of the fields and call them in order to utilize the app.\nImplement the program's logic, regardless of what it might be.\n\n**Note:** Because of different limitations, if you want to write a test, you must first\nplace the module in which you built the struct outside of the test macro. Once the struct\nhas been built, you may then test it by calling it within the test macro itself.\nThe examples it provides can also be found in the testing done by this library itself.\n\n**Note:** this library is only supported on versions of `Elixir 1.15` and higher, as well as `OTP 26`, \nand that the manufacturer does not offer bug patches for problems that occur in older software versions.\n\n**Note:** All of this library's dependencies are optional; nonetheless,\nif you require their use in your program, you will need to include them. We provide further\nexplanation on the topic in the area you're looking for.\n\n> Before continuing with the discussion about the library section and also offering practical\nexamples in this field, it is important to understand that when you construct a struct in a module,\nafter compilation in the runtime of the program, each module includes the following functional functions:\n\n1. The `builder()` function is actually an action function, and it requires you to provide it with\ninformation in the form of a `map`.\n\n2. The `enforce_keys()` function: this method returns the necessary keys of the first layer of the\nstruct. However, if you want to display all of the keys of the nested struct,\nyou will need to enter the `:all` input, which is not yet implemented in this version.\n\n3. The `keys()` function has the same requirements as the `enforce_keys()`\nfunction, with the exception that it returns all of the keys, including the ones that aren't necessary.\n\n---\n\n**And also, any data that enters the `builder` function must go through the following path:**\n\n1. If the `map` currently uses the `string` data type, it will be converted to the `atom` data type.\n\n2. Eliminates the keys from the `struct` that are not present in the list\n\n3. Determines whether or not all of the essential keys have been transmitted.\n\n4. If you write your own custom validation, each field's validations will be checked.\n\n> It is important to notice that regardless of the circumstances, this macro also inspects the module itself.\nIf there is a `validator` function but none of the functions are set,\nit calls the validator function directly from the module itself into the field itself.\n\n5. The output of the complete `struct` is entered into the mother validation,\nand the programmer is given the opportunity to write for the final output in this validation.\nThis validation also provides the possibility of writing for the output of the struct.\n\n> This macro will call the struct's `main_validator` directly from the module\nit has been placed in if, in this section, the `main_validator`  is not set in the\nstruct but is found in the module that contains the struct.\n\n6. If there were no problems in the previous phases (it is important to note that options 4 and 5 are not required),\nit will proceed to the next level of the program, which is the validation and custom Sanitizer stage.\n\n7. To begin, the Sanitizer will alter the data so that it corresponds to what you have called in each field,\nand it will not return any errors.\nEven if the Sanitizer programmer is not utilized in the required type as a result of an accidental oversight,\nthe data will still be passed to the following stage.\n\n8. At this point, it will return an error or data for each field, depending on the validations that you called.\n\n9. At the end of the process, you will receive a tuple that will either have problems in it or\nthe final data with an ok status.\n\n> It is important to keep in mind that if your `struct` is nested, all of the internal errors\nof these structs are also included in the list of problems. Additionally,\nthe data will be sent to you when the status is positive, but only if you have called the parent of this struct.\n\n> Note that each nested struct can be used on its own and possesses all of the\ncapabilities that have been discussed thus far. For instance, if you have module `A` and\nyou utilized the `sub_field` that is named `auth` in it, you may now use it separately from the `A.Auth` Use. Use.\n\n---\n\n#","ref":"GuardedStruct.html#guardedstruct/2-defines-a-guarded-struct"},{"type":"macro","title":"Examples - GuardedStruct.guardedstruct/2","doc":"1. ##","ref":"GuardedStruct.html#guardedstruct/2-examples"},{"type":"macro","title":"Defining a struct layer without additional options - GuardedStruct.guardedstruct/2","doc":"```elixir\ndefmodule MyStruct do\n  use GuardedStruct\n\n  guardedstruct do\n    field :field_one, String.t()\n    field :field_two, integer(), enforce: true\n    field :field_three, boolean(), enforce: true\n    field :field_four, atom(), default: :hey\n  end\nend\n```\n\n---\n\n2. ##","ref":"GuardedStruct.html#guardedstruct/2-defining-a-struct-layer-without-additional-options"},{"type":"macro","title":"Define a struct with settings related to essential keys or `opaque` type - GuardedStruct.guardedstruct/2","doc":"###","ref":"GuardedStruct.html#guardedstruct/2-define-a-struct-with-settings-related-to-essential-keys-or-opaque-type"},{"type":"macro","title":"Options - GuardedStruct.guardedstruct/2","doc":"* `enforce` - if set to true, sets `enforce: true` to all fields by default.\nThis can be overridden by setting `enforce: false` or a default value on\nindividual fields.\n* `opaque` - if set to true, creates an opaque type for the struct.\n* `module` - if set, creates the struct in a submodule named `module`.\n\n```elixir\ndefmodule MyModule do\n  use GuardedStruct\n\n  guardedstruct enforce: true do\n    field(:enforced_by_default, term())\n    field(:not_enforced, term(), enforce: false)\n    field(:with_default, integer(), default: 1)\n    field(:with_false_default, boolean(), default: false)\n    field(:with_nil_default, term(), default: nil)\n  end\nend\n\n# OR opaque\n\ndefmodule MyModule do\n  use GuardedStruct\n\n  guardedstruct opaque: true do\n    field(:enforced_by_default, term())\n    field(:not_enforced, term(), enforce: false)\n    field(:with_default, integer(), default: 1)\n    field(:with_false_default, boolean(), default: false)\n    field(:with_nil_default, term(), default: nil)\n  end\nend\n\n# OR opaque\n\ndefmodule MyModule do\n  use GuardedStruct\n\n  guardedstruct do\n    field(:enforced_by_default, term())\n    field(:not_enforced, term(), enforce: true)\n    field(:with_default, integer(), default: 1)\n    field(:with_false_default, boolean(), default: false)\n    field(:with_nil_default, term(), default: nil)\n  end\nend\n\n# OR create sub module\n\ndefmodule TestModule do\n  use GuardedStruct\n\n  guardedstruct module: Struct do\n    field(:field, term())\n  end\nend\n```\n\n---\n\n3. ##","ref":"GuardedStruct.html#guardedstruct/2-options"},{"type":"macro","title":"Defining the struct by calling the validation module or calling from the module that contains the struct - GuardedStruct.guardedstruct/2","doc":"###","ref":"GuardedStruct.html#guardedstruct/2-defining-the-struct-by-calling-the-validation-module-or-calling-from-the-module-that-contains-the-struct"},{"type":"macro","title":"Options - GuardedStruct.guardedstruct/2","doc":"* `validator` - if set as tuple like this {ModuleName, :function_name} for each field,\nin fact you have a `builder` function that check the validation.\n\n```elixir\n# First, it looks at whether a validator has been set for each field,\n# otherwise it looks inside the module.\ndefmodule MyModule do\n  alias MyModule.AnotherModule\n  use GuardedStruct\n\n  guardedstruct do\n    field(:name, String.t(), validator: {AnotherModule, :validator})\n    field(:title, String.t())\n  end\n\n  def validator(:title, value) do\n    {:ok, :title, value}\n  end\n\n  # You can not use it, but it is mentioned here for test clarity\n  def validator(name, value) do\n    {:ok, name, value}\n  end\nend\n```\n\n- Output without error: `{:ok, :field_name, value}`\n- Output with error: `{:error, :field_name, ERROR MESSAGE}`\n\n---\n\n4. ##","ref":"GuardedStruct.html#guardedstruct/2-options"},{"type":"macro","title":"Define the struct by calling the `main_validator` for full access on the output - GuardedStruct.guardedstruct/2","doc":"###","ref":"GuardedStruct.html#guardedstruct/2-define-the-struct-by-calling-the-main_validator-for-full-access-on-the-output"},{"type":"macro","title":"Options - GuardedStruct.guardedstruct/2","doc":"* `main_validator` - if set as tuple like this {ModuleName, :function_name},\nfor guardedstruct, in fact you have a global validation.\n\n```elixir\n# First, it looks at whether a main_validator has been set for each field,\n# otherwise it looks inside the module.\ndefmodule MyModule do\n  alias MyModule.AnotherModule\n  use GuardedStruct\n\n  guardedstruct main_validator: {AnotherModule, :main_validator} do\n  field(:name, String.t())\n  field(:title, String.t())\n  end\n\n  # if `guardedstruct` has no `main_validator` which is configed\n  def main_validator(value) do\n    {:ok, value}\n  end\nend\n```\n\n- Output without error: `{:ok, value}`\n- Output with error: `{:error, :generalـreason, errors_list}`\n\n---\n\n5. ##","ref":"GuardedStruct.html#guardedstruct/2-options"},{"type":"macro","title":"Define struct with `derive` - GuardedStruct.guardedstruct/2","doc":"> derive is divided into two parts: `validate` and `sanitize`, which is priority with `sanitize`\n\n**It should be noted that in the following tables you can see that in order to use some derives, you need to add its dependency on your project.**\n\n\n##","ref":"GuardedStruct.html#guardedstruct/2-define-struct-with-derive"},{"type":"macro","title":"Sanitize - GuardedStruct.guardedstruct/2","doc":"| How to use | Dependencies | Description |\n| ---------- | ------------ | ----------- |\n| `\"sanitize(trim)\"` | NO | Trim your string |\n| `\"sanitize(upcase)\"` | NO | Upcase your string |\n| `\"sanitize(downcase)\"` | NO | Downcase your string |\n| `\"sanitize(capitalize)\"` | NO | Capitalize your string |\n| `\"sanitize(basic_html)\"` | `:html_sanitize_ex` | Sanitize your string base on `basic_html` |\n| `\"sanitize(html5)\"` | `:html_sanitize_ex` | Sanitize your string base on `html5` |\n| `\"sanitize(markdown_html)\"` | `:html_sanitize_ex` | Sanitize your string base on `markdown_html` |\n| `\"sanitize(strip_tags)\"` | `:html_sanitize_ex` | Sanitize your string base on `strip_tags` |\n| `\"sanitize(tag)\"` | `:html_sanitize_ex` | Sanitize your string base on `html_sanitize_ex` selection |\n| `\"sanitize(string_float)\"` | `:html_sanitize_ex` or `none` | Sanitize your string base on `html_sanitize_ex` and `Float.parse/1` |\n\n##","ref":"GuardedStruct.html#guardedstruct/2-sanitize"},{"type":"macro","title":"Validate - GuardedStruct.guardedstruct/2","doc":"| How to use | Dependencies | Description |\n| ---------- | ------------ | ----------- |\n| `\"validate(string)\"` | NO | Validate if the data is string|\n| `\"validate(integer)\"` | NO | Validate if the data is integer|\n| `\"validate(list)\"` | NO | Validate if the data is list|\n| `\"validate(atom)\"` | NO | Validate if the data is atom|\n| `\"validate(bitstring)\"` | NO | Validate if the data is bitstring|\n| `\"validate(boolean)\"` | NO | Validate if the data is boolean|\n| `\"validate(exception)\"` | NO | Validate if the data is exception|\n| `\"validate(float)\"` | NO | Validate if the data is float|\n| `\"validate(function)\"` | NO | Validate if the data is function|\n| `\"validate(map)\"` | NO | Validate if the data is map|\n| `\"validate(nil_value)\"` | NO | Validate if the data is nil value|\n| `\"validate(not_nil_value)\"` | NO | Validate if the data is not nil value|\n| `\"validate(number)\"` | NO | Validate if the data is number|\n| `\"validate(pid)\"` | NO | Validate if the data is Elixir pid|\n| `\"validate(port)\"` | NO | Validate if the data is Elixir port|\n| `\"validate(reference)\"` | NO | Validate if the data is Elixir reference|\n| `\"validate(struct)\"` | NO | Validate if the data is struct|\n| `\"validate(tuple)\"` | NO | Validate if the data is tuple|\n| `\"validate(not_empty)\"` | NO | Validate if the data is not empty - binary, map, list|\n| `\"validate(max_len=10)\"` | NO | Validate if the data is more than 10 - Range, integer, binary|\n| `\"validate(min_len=10)\"` | NO | Validate if the data is less than 10 - Range, integer, binary|\n| `\"validate(url)\"` | NO | Validate if the data is url|\n| `\"validate(geo_url)\"` | `ex_url` | Validate if the data is geo url|\n| `\"validate(tell)\"` | `ex_url` | Validate if the data is tell|\n| `\"validate(tell=98)\"` | `ex_url` | Validate if the data is tell with country code|\n| `\"validate(email)\"` | `email_checker` | Validate if the data is email|\n| `\"validate(location)\"` | `ex_url` | Validate if the data is location|\n| `\"validate(string_boolean)\"` | NO | Validate if the data is string boolean|\n| `\"validate(datetime)\"` | NO | Validate if the data is datetime|\n| `\"validate(range)\"` | NO | Validate if the data is datetime|\n| `\"validate(date)\"` | NO | Validate if the data is datetime|\n| `\"validate(regex='^[a-zA-Z]+@mishka.group$')\"` | NO | Validate if the data is match with regex|\n| `\"validate(ipv4)\"` | NO | Validate if the data is ipv4|\n| `\"validate(not_empty_string)\"` | NO | Validate if the data is not empty string|\n| `\"validate(uuid)\"` | NO | Validate if the data is uuid|\n| `\"validate(enum=String[admin::user::banned])\"` | NO | Validate if the data is one of the enum value, which is String|\n| `\"validate(enum=Atom[admin::user::banned])\"` | NO | Validate if the data is one of the enum value, which is Atom|\n| `\"validate(enum=Integer[1::2::3])\"` | NO | Validate if the data is one of the enum value, which is Integer|\n| `\"validate(enum=Float[1.5::2.0::4.5])\"` | NO | Validate if the data is one of the enum value, which is Float|\n| `\"validate(enum=Map[%{status: 1}::%{status: 2}::%{status: 3}])\"` | NO | Validate if the data is one of the enum value, which is Map|\n| `\"validate(enum=Tuple[{:admin, 1}::{:user, 2}::{:banned, 3}])\"` | NO | Validate if the data is one of the enum value, which is Tuple|\n| `\"validate(equal=some_thing)\"` | NO | Validate if the data is equal with validation value, which is any type|\n| `\"validate(either=[string, enum=Integer[1::2::3]])\"` | NO | Validate if the data is valid with each derive validation|\n| `\"validate(custom=[Enum, all?])\"` | NO | Validate if the you custom function returns true, **Please read section 20**|\n| `\"validate(some_string_float)\"` | NO | Validate if the string data is float (Somewhat by removing the string)|\n| `\"validate(string_float)\"` | NO | Validate if the string data is float (Strict mode)|\n| `\"validate(string_integer)\"` | NO | Validate if the string data is integer (Strict mode)|\n| `\"validate(some_string_integer)\"` | NO | Validate if the string data is integer (Somewhat by removing the string)|\n| `\"validate(not_flatten_empty)\"` | NO | Validate the list if it is empty by summing and flattening the entire list|\n| `\"validate(not_flatten_empty_item)\"` | NO | Validate the list if it is empty by summing and flattening the entire list and first level children|\n\n```elixir\ndefmodule MyModule do\n  use GuardedStruct\n\n  guardedstruct do\n    field(:id, integer(), derive: \"sanitize(trim) validate(integer, max_len=20, min_len=5)\")\n    field(:title, String.t(), derive: \"sanitize(trim, upcase) validate(not_empty_string)\")\n    field(:name, String.t(), derive: \"sanitize(trim, capitalize) validate(string, not_empty, max_len=20)\")\n  end\nend\n```\n\n---\n\n6. ##","ref":"GuardedStruct.html#guardedstruct/2-validate"},{"type":"macro","title":"Extending `derive` section - GuardedStruct.guardedstruct/2","doc":"###","ref":"GuardedStruct.html#guardedstruct/2-extending-derive-section"},{"type":"macro","title":"Options - GuardedStruct.guardedstruct/2","doc":"* `validate_derive` - It can be just one module or a list of modules\n* `sanitize_derive` - It can be just one module or a list of modules\n\n```elixir\ndefmodule TestValidate do\n  def validate(:testv1, input, field) do\n    if is_binary(input),\n      do: input,\n      else: {:error, field, :testv1, \"The name field must not be empty\"}\n  end\nend\n\ndefmodule TestValidate2 do\n  def validate(:testv2, input, field) do\n    if is_binary(input),\n      do: input,\n      else: {:error, field, :testv1, \"The name field must not be empty\"}\n  end\nend\n\ndefmodule TestSanitize do\n  def sanitize(:capitalize_v1, input) do\n    if is_binary(input), do: String.capitalize(input), else: input\n  end\nend\n\ndefmodule TestSanitize2 do\n  def sanitize(:capitalize_v2, input) do\n    if is_binary(input), do: String.capitalize(input), else: input\n  end\nend\n\ndefmodule MyModule do\n  use GuardedStruct\n\n  guardedstruct validate_derive: TestValidate, sanitize_derive: TestSanitize do\n    field(:id, integer(), derive: \"sanitize(trim) validate(not_exist)\")\n    field(:title, String.t(), derive: \"sanitize(trim) validate(string)\")\n    field(:name, String.t(), derive: \"sanitize(capitalize_v2) validate(string)\")\n  end\nend\n\n# OR you can extend with list of modules\n\ndefmodule MyModule do\n  use GuardedStruct\n\n  guardedstruct validate_derive: [TestValidate, TestValidate2], sanitize_derive: [TestSanitize, TestSanitize2] do\n    field(:id, integer(), derive: \"validate(ineteger)\")\n    field(:title, String.t(), derive: \"sanitize(trim) validate(string)\")\n    field(:name, String.t(), derive: \"sanitize(capitalize_v2) validate(string)\")\n  end\nend\n```\n---\n\n7. ##","ref":"GuardedStruct.html#guardedstruct/2-options"},{"type":"macro","title":"Struct definition with `validator` and `derive` simultaneously - GuardedStruct.guardedstruct/2","doc":"```elixir\n# In this code, name field has not custom validator module and function\n# Then it see the caller module for it\ndefmodule MyModule do\n  use GuardedStruct\n\n  guardedstruct do\n    field(:name, String.t(),\n      enforce: true,\n      derive: \"sanitize(trim, upcase) validate(not_empty)\"\n    )\n\n    field(:title, String.t(), derive: \"sanitize(trim, capitalize) validate(not_empty)\")\n  end\n\n  def validator(:name, value) do\n    if is_binary(value), do: {:ok, :name, \"Mishka   \"}, else: {:error, :name, \"No, never\"}\n  end\n\n  def validator(name, value) do\n    {:ok, name, value}\n  end\nend\n\n# OR with custom validator\n\ndefmodule MyModule do\n  alias MyModule.AnotherModule\n  use GuardedStruct\n\n  guardedstruct do\n    field(:name, String.t(),\n      enforce: true,\n      derive: \"sanitize(trim, capitalize) validate(not_empty)\",\n      validator: {AnotherModule, :validator}\n    )\n    field(:title, String.t(), derive: \"sanitize(trim, capitalize) validate(not_empty)\")\n  end\n\n  # You can not use it, but it is mentioned here for test clarity\n  def validator(name, value) do\n    {:ok, name, value}\n  end\nend\n```\n---\n\n8. ##","ref":"GuardedStruct.html#guardedstruct/2-struct-definition-with-validator-and-derive-simultaneously"},{"type":"macro","title":"Define a nested and complex struct - GuardedStruct.guardedstruct/2","doc":"```elixir\ndefmodule TestNestedStruct do\n  use GuardedStruct\n\n  guardedstruct do\n    field(:name, String.t(),\n      derive:\n        \"sanitize(strip_tags, trim, capitalize) validate(string, not_empty, max_len=20, min_len=3)\"\n    )\n\n    field(:family, String.t(),\n      derive:\n        \"sanitize(basic_html, trim, capitalize) validate(string, not_empty, max_len=20, min_len=3)\"\n    )\n\n    field(:age, integer(), enforce: true, derive: \"validate(integer, max_len=110, min_len=18)\")\n\n    sub_field(:auth, struct(), enforce: true) do\n      field(:server, String.t(), derive: \"validate(regex='^[a-zA-Z]+@mishka.group$')\")\n\n      field(:identity_provider, String.t(),\n        derive: \"sanitize(strip_tags, trim, lowercase) validate(not_empty)\"\n      )\n\n      sub_field(:role, struct(), enforce: true) do\n        field(:name, String.t(),\n          derive:\n            \"sanitize(strip_tags, trim, lowercase) validate(enum=Atom[admin::user::banned])\"\n        )\n\n        field(:action, String.t(), derive: \"validate(string_boolean)\")\n\n        field(:status, String.t(),\n          derive: \"validate(enum=Map[%{status: 1}::%{status: 2}::%{status: 3}])\"\n        )\n      end\n\n      field(:last_activity, String.t(), derive: \"sanitize(strip_tags, trim) validate(datetime)\")\n    end\n\n    sub_field(:profile, struct()) do\n      field(:site, String.t(), derive: \"validate(url)\")\n\n      field(:nickname, String.t(), validator: {TestNestedStruct, :validator})\n    end\n\n    field(:username, String.t(),\n      enforce: true,\n      derive: \"sanitize(tag=strip_tags) validate(not_empty, max_len=20, min_len=3)\"\n    )\n  end\n\n  def validator(:nickname, value) do\n    if is_binary(value),\n      do: {:ok, :nickname, value},\n      else: {:error, :nickname, \"Invalid nickname\"}\n  end\n\n  def validator(field, value) do\n    {:ok, field, value}\n  end\nend\n```\n\n9. ##","ref":"GuardedStruct.html#guardedstruct/2-define-a-nested-and-complex-struct"},{"type":"macro","title":"Error and data output sample - GuardedStruct.guardedstruct/2","doc":"```elixir\n# Error\n{:error, :bad_parameters,\n  [\n    %{\n      field: :profile,\n      errors: {:bad_parameters, [%{message: \"Invalid nickname\", field: :nickname}]}\n    },\n    %{\n      field: :auth,\n      errors:\n        {:bad_parameters,\n        [\n          %{message: _msg, field: :last_activity, action: :datetime},\n          %{\n            field: :role,\n            errors:\n              {:bad_parameters,\n                [\n                  %{message: _msg1, field: :action, action: :string_boolean}\n                ]}\n          }\n        ]}\n    }\n  ]}\n\n# Data\n\n{:ok,\n  %MishkaDeveloperToolsTest.GuardedStructTest.TestNestedStruct{\n    username: \"mishka\",\n    profile: %MishkaDeveloperToolsTest.GuardedStructTest.TestNestedStruct.Profile{\n      nickname: \"mishka\",\n      site: \"https://elixir-lang.org\"\n    },\n    auth: %MishkaDeveloperToolsTest.GuardedStructTest.TestNestedStruct.Auth{\n      last_activity: \"2023-08-20 16:54:07.841434Z\",\n      role: %MishkaDeveloperToolsTest.GuardedStructTest.TestNestedStruct.Auth.Role{\n        action: \"true\",\n        name: :user,\n        status: %{status: 2}\n      },\n      identity_provider: \"google\",\n      server: \"users@mishka.group\"\n    },\n    age: 18,\n    family: \"Group\",\n    name: \"Mishka\"\n  }}\n```\n\n10. ##","ref":"GuardedStruct.html#guardedstruct/2-error-and-data-output-sample"},{"type":"macro","title":"Set config to show error inside `defexception` - GuardedStruct.guardedstruct/2","doc":"You may want to display the received errors in Elixir's `defexception`. you just need to enable the\n`error: true` for `guardedstruct` macro or `sub_field`.\n\n**Note**: When you enable the `error` option. This macro will generate for you a module that\nis part of the parent module subset, and within that module, it will generate a `defexception` struct.\n\n###","ref":"GuardedStruct.html#guardedstruct/2-set-config-to-show-error-inside-defexception"},{"type":"macro","title":"Error `defexception` modules - GuardedStruct.guardedstruct/2","doc":"```elixir\nTestCallNestedStructWithError.Error\nTestCallNestedStructWithError.Auth.Error\nTestCallNestedStructWithError.Auth.Path.Error\n```\n\n###","ref":"GuardedStruct.html#guardedstruct/2-error-defexception-modules"},{"type":"macro","title":"Sample code - GuardedStruct.guardedstruct/2","doc":"```elixir\ndefmodule TestCallNestedStructWithError do\n  use GuardedStruct\n\n  guardedstruct error: true do\n    field(:name, String.t(), derive: \"validate(string)\")\n\n    sub_field(:auth, struct(), error: true) do\n      field(:action, String.t(), derive: \"validate(not_empty)\")\n\n      sub_field(:path, struct(), error: true) do\n        field(:name, String.t())\n      end\n    end\n  end\nend\n\n# And you should call it like this, the second entry should be `true` or `false` to show error `defexception`\nTestCallNestedStructWithError.builder(%{name: 1}, true)\n```\n\n11. #### `authorized_fields` option to limit user input\n\nIf this option is not used, the program will automatically drop fields that are not defined;\nhowever, if this option is set, it will return an error to the user if they transmit a field\nthat is not in the list of specified fields. If this option is not used, the program will automatically\ndrop fields that are not defined.\n\n**Please take note** that the `required_fields` and this section are not the same thing,\nand that the validation of the mandatory fields will take place after this section.\n\n```elixir\ndefmodule TestAuthorizeKeys do\n  use GuardedStruct\n\n  guardedstruct authorized_fields: true do\n    field(:name, String.t(), derive: \"validate(string)\")\n\n    sub_field(:auth, struct(), authorized_fields: true) do\n      field(:action, String.t(), derive: \"validate(not_empty)\")\n\n      sub_field(:path, struct()) do\n        field(:name, String.t())\n      end\n    end\n  end\nend\n\nTestAuthorizeKeys.builder(%{name: \"Shahryar\", test: \"test\"})\n# Ouput: `{:error, :authorized_fields, [:test]}`\n\nTestAuthorizeKeys.builder(%{name: \"Shahryar\", auth: %{action: \"admin\", test: \"test\"}})\n# Ouput: `{:error, :bad_parameters, [%{field: :auth, errors: {:authorized_fields, [:test]}}]}`\n```\n\n12. #### `authorized_fields` option to limit user input\n\nThis option can be helpful for you if you wish to construct your own modules in various files\nand then make those modules reusable in the future. Simply implement the macro in another module,\nand then call that module from the `field` macro. The `struct` and `structs` options are the\nones in which the module can be placed. The first one will provide you with an indication that you\nwill be given a map, and the second one will provide you with a list of maps.\n\n\n```elixir\ndefmodule TestAuthStruct do\n  use GuardedStruct\n\n  guardedstruct do\n    field(:action, String.t(), derive: \"validate(not_empty)\")\n  end\nend\n\ndefmodule TestOnValueStruct do\n  use GuardedStruct\n\n  guardedstruct do\n    field(:name, String.t(), derive: \"validate(string)\")\n    field(:auth_path, struct(), struct: TestAuthStruct)\n    # field(:auth_path, struct(), structs: TestAuthStruct)\n  end\nend\n```\n\n13. ##","ref":"GuardedStruct.html#guardedstruct/2-sample-code"},{"type":"macro","title":"List of structs - GuardedStruct.guardedstruct/2","doc":"As was discussed in the earlier available choices. In the `field` macro that is used to\ncall **another module**, as well as in the `sub_field` macro, you have the ability to retrieve\na list of structs rather than a single struct.\n\n```elixir\ndefmodule TestUserAuthStruct do\n  use GuardedStruct\n\n  guardedstruct do\n    field(:name, String.t(), derive: \"validate(not_empty)\")\n    field(:auth_path, struct(), structs: TestAuthStruct)\n\n    sub_field(:profile, list(struct()), structs: true) do\n      field(:github, String.t(), enforce: true, derive: \"validate(url)\")\n      field(:nickname, String.t(), derive: \"validate(not_empty)\")\n    end\n  end\nend\n\nTestUserAuthStruct.builder(%{\n         name: \"mishka\",\n         auth_path: [\n           %{action: \"*:admin\", path: %{role: \"1\"}},\n           %{action: \"*:user\", path: %{role: \"3\"}}\n         ]\n       })\n\n# OR\nTestUserAuthStruct.builder(%{\n         name: \"mishka\",\n         auth_path: [\n           %{action: \"*:admin\", path: %{role: \"1\"}},\n           %{action: \"*:user\", path: %{role: \"3\", rel: %{social: \"github\"}}}\n         ],\n         profile: [%{github: \"https://github.com/mishka-group\"}]\n       })\n```\n\n14. ##","ref":"GuardedStruct.html#guardedstruct/2-list-of-structs"},{"type":"macro","title":"Struct information function - GuardedStruct.guardedstruct/2","doc":"You will need to include a function known as `__information__()` in each and every module\nthat you develop for your very own `structs`. This function will store a variety of information, such as keys,\ncallers, and so on.\n\n**Note:** There is a possibility that further information will be added to this function; please check its\noutput after each update.\n\n**Note:** If you call another Struct module within the `field` macro, you should not use\nthe `caller` key within this function. This is due to the fact that the constructor information\nis only available during **compile** time, and not run time.\n\n```elixir\nTestStruct.__information__()\n```\n\n15. ##","ref":"GuardedStruct.html#guardedstruct/2-struct-information-function"},{"type":"macro","title":"Transmitting whole output of builder function to its children - GuardedStruct.guardedstruct/2","doc":"Because new keys have been added, such as `auto`, `on`, and `from` which will be explained\nin more detail below. The `builder` function is available in the following two different styles.\n\n> If you don't provide the `:root` key, you can just specify the child key,\nbut if you do, you have to send the entire map as an `attar`. This is something to keep in mind.\n\n\n```elixir\ndef builder(attrs, error)\n\ndef builder({key, attrs} = input, error)\n    when is_tuple(input) and is_map(attrs) and is_list(key) do\n      ...\nend\n```\n\n16. ##","ref":"GuardedStruct.html#guardedstruct/2-transmitting-whole-output-of-builder-function-to-its-children"},{"type":"macro","title":"Auto core key - GuardedStruct.guardedstruct/2","doc":"Even if the user transmits the information and it is already in the input, such as with the ID field,\nthe sequence of fields still has to be formed automatically. You can accomplish what you want to with\nthe help of the `auto` option.\n\n> As you can see in the code below, we have several types of `auto` option calls\n\n---\n\n> When the core keys are called, the entire primary map is sent to each child.\n\n```elixir\ndefmodule TestAutoValueStruct do\n  use GuardedStruct\n\n  guardedstruct do\n    field(:username, String.t(), derive: \"validate(not_empty)\")\n    field(:user_id, String.t(), auto: {Ecto.UUID, :generate})\n    field(:parent_id, String.t(), auto: {Ecto.UUID, :generate})\n\n    sub_field(:profile, struct()) do\n      field(:id, String.t(), auto: {Ecto.UUID, :generate})\n      field(:nickname, String.t(), derive: \"validate(not_empty)\")\n\n      sub_field(:social, struct()) do\n        field(:id, String.t(), auto: {TestAutoValueStruct, :create_uuid, \"test-path\"})\n        field(:skype, String.t(), derive: \"validate(string)\")\n        field(:username, String.t(), from: \"root::username\")\n      end\n    end\n\n    sub_field(:items, struct(), structs: true) do\n      field(:id, String.t(), auto: {Ecto.UUID, :generate})\n      field(:something, String.t(), derive: \"validate(string)\", from: \"root::username\")\n    end\n  end\n\n  def create_uuid(default) do\n    Ecto.UUID.generate()   \"-#{default}\"\n  end\nend\n```\n\n> **Note**: When changing a record in the database, for example, you might need to make sure that a particular\n> piece of data does not get overwritten by an automatic piece of data if one already exists.\n> To find a solution to this issue, you will need to invoke the `builder` function in the following manner.\n\n```elixir\nTestModule.builder({:root, %{username: \"mishka\", user_id: \"test_not_to_be_replaced\"}, :edit})\n```\n\nThe desired key can be derived from the information that was supplied by the user,\nand it is stored in the first entry of the `Tuple`. If it is `:root` or `[:root]`, it indicates that the entire\ndata set is being referred to, and if it is a special key that must be valued as a list,\nit indicates that the `builder` will begin its operation from that particular key.\nIt is important to notice that the key has to be `sub_field` if the path is chosen to be displayed.\n\n17. ##","ref":"GuardedStruct.html#guardedstruct/2-auto-core-key"},{"type":"macro","title":"On core key - GuardedStruct.guardedstruct/2","doc":"With the aid of this option, you can make the presence of a field dependent on the presence of another field and,\nif there is no error, produce an error message.\n\nIf you pay attention to the routing method, the routing will start from the sent map itself\nif `:root` is specified, but if it is not used, the routing will start from the received\nmap in the child if it is not used.\n\n> When the core keys are called, the entire primary map is sent to each child.\n\n###","ref":"GuardedStruct.html#guardedstruct/2-on-core-key"},{"type":"macro","title":"Note: - GuardedStruct.guardedstruct/2","doc":"> By default, `on` core key is called when the value of the calling field is sent;\n> To force the field to be non-empty, you must use enforce.\n\n```elixir\ndefmodule TestOnValueStruct do\n  use GuardedStruct\n\n  guardedstruct do\n    field(:name, String.t(), derive: \"validate(string)\")\n\n    sub_field(:profile, struct()) do\n      field(:id, String.t(), auto: {Ecto.UUID, :generate})\n      field(:nickname, String.t(), on: \"root::name\", derive: \"validate(string)\")\n      field(:github, String.t(), derive: \"validate(string)\")\n\n      sub_field(:identity, struct()) do\n        field(:provider, String.t(), on: \"root::profile::github\", derive: \"validate(string)\")\n        field(:id, String.t(), auto: {Ecto.UUID, :generate})\n        field(:rel, String.t(), on: \"sub_identity::auth_path::action\")\n\n        sub_field(:sub_identity, struct()) do\n          field(:id, String.t(), auto: {Ecto.UUID, :generate})\n          field(:auth_path, struct(), struct: TestAuthStruct)\n        end\n      end\n    end\n\n    sub_field(:last_activity, list(struct()), structs: true) do\n      field(:action, String.t(), enforce: true, derive: \"validate(string)\", on: \"root::name\")\n    end\n  end\nend\n```\n18. ##","ref":"GuardedStruct.html#guardedstruct/2-note"},{"type":"macro","title":"From core key - GuardedStruct.guardedstruct/2","doc":"You can select this alternative if you require any data that was delivered in another key\nto be incorporated into the key that you are looking for. If the key is present, the data\nassociated with it will be copied; however, if the key is not there, the data in and of itself will be retained.\n\nIf you pay attention to the routing method, the routing will start from the sent map itself\nif `:root` is specified, but if it is not used, the routing will start from the received map\nin the child if it is not used.\n\n---\n\n> When the core keys are called, the entire primary map is sent to each child.\n\n> Note: It is possible that you will need to check that the field you wish to duplicate exists,\nand in order to do so, you can use either the `on` key or the `enforce` option.\n\n```elixir\ndefmodule TestAutoValueStruct do\n  use GuardedStruct\n\n  guardedstruct do\n    field(:username, String.t(), derive: \"validate(not_empty)\")\n    field(:user_id, String.t(), auto: {Ecto.UUID, :generate})\n    field(:parent_id, String.t(), auto: {Ecto.UUID, :generate})\n\n    sub_field(:profile, struct()) do\n      field(:id, String.t(), auto: {Ecto.UUID, :generate})\n      field(:nickname, String.t(), derive: \"validate(not_empty)\")\n\n      sub_field(:social, struct()) do\n        field(:id, String.t(), auto: {TestAutoValueStruct, :create_uuid, \"test-path\"})\n        field(:skype, String.t(), derive: \"validate(string)\")\n        field(:username, String.t(), from: \"root::username\")\n      end\n    end\n\n    sub_field(:items, struct(), structs: true) do\n      field(:id, String.t(), auto: {Ecto.UUID, :generate})\n      field(:something, String.t(), derive: \"validate(string)\", from: \"root::username\")\n    end\n  end\n\n  def create_uuid(default) do\n    Ecto.UUID.generate()   \"-#{default}\"\n  end\nend\n```\n\n19. ##","ref":"GuardedStruct.html#guardedstruct/2-from-core-key"},{"type":"macro","title":"Domain core key - GuardedStruct.guardedstruct/2","doc":"When dealing with a structure that is heavily nested, it is occasionally necessary\nto establish the permitted range of values for a set of parameters based on the\ninput provided by a parent.\nNote that similar to earlier parts, we do not transfer the entirety of either\nthe `Struct` or the `Map` to this feature in this particular section.\nAlways keep in mind the top-down structure, often known as the parent-to-child relationship.\n\n```elixir\ndefmodule AllowedParentDomain do\n  use GuardedStruct\n\n  guardedstruct authorized_fields: true do\n    field(:username, String.t(),\n      domain: \"!auth.action=String[admin, user]::?auth.social=Atom[banned]\",\n      derive: \"validate(string)\"\n    )\n\n    field(:type_social, String.t(),\n      domain: \"?auth.type=Map[%{name: \"mishka\"}, %{name: \"mishka2\"}]\",\n      derive: \"validate(string)\"\n    )\n\n    sub_field(:auth, struct(), authorized_fields: true) do\n      field(:action, String.t(), derive: \"validate(not_empty)\")\n      field(:social, atom(), derive: \"validate(atom)\")\n      field(:type, map(), derive: \"validate(map)\")\n    end\n  end\nend\n```\n\n**Please see the `domain` core key, for example:**\n\n```elixir\ndomain: \"!auth.action=String[admin, user]::?auth.social=Atom[banned]\"\n```\n\n**In this part:**\n- If `username` key is sent you must have `auth.action` path which is string `admin` or string `user`\n- If `username` key is sent you you can have `auth.social` path which is just atom `:banned`\n- So the `auth.social` can be nil and inside user input impossible nil\n\n**Note**: Within this section of the core keys, we are making use of the `:enum` Derive.\nYou are free to make advantage of any and all of the amenities that this Derive provides.\n\n---\n\n**Note:**:\n\nIt is important to think about the fact that the `domain` core key does not\nconsider any update of  the `auto` core key and instead examines the data that was initially entered in the `builder`.\nThe information that was entered is not altered in any way by this function; it is merely validating it.\n\n---\n\n19. ##","ref":"GuardedStruct.html#guardedstruct/2-domain-core-key"},{"type":"macro","title":"Domain core key with `equal` and `either` support - GuardedStruct.guardedstruct/2","doc":"This component supplies all of the facilities that are necessary to be able to utilize the\ntwo keys labeled `equal` and `either`, but because of a little interference, its style is\ndifferent from the original style of each of these keys, and you are required to adhere to\nthese guidelines. Play can be found in this section.\n\n###","ref":"GuardedStruct.html#guardedstruct/2-domain-core-key-with-equal-and-either-support"},{"type":"macro","title":"Example for `equal` - GuardedStruct.guardedstruct/2","doc":"```elixir\n\"?auth.equal=Equal[Atom>>name]\"\n```\n\n###","ref":"GuardedStruct.html#guardedstruct/2-example-for-equal"},{"type":"macro","title":"Example for `either` - GuardedStruct.guardedstruct/2","doc":"```elixir\ndomain: \"?auth.either=Either[string, enum>>Integer[1>>2>>3]]\"\n```\n\n**Note**: As you can see, the `>>` indicator has been utilized in this area,\ndespite the fact that it was not included in the first version of these validations.\n\n20. ##","ref":"GuardedStruct.html#guardedstruct/2-example-for-either"},{"type":"macro","title":"Domain core key with Custom function support - GuardedStruct.guardedstruct/2","doc":"Imagine that you have a function that determines for you whether or not the data that has been sent is valid.\n\n**Note**: the function is required to have an input.\n**Note**: the function must return either true or false.\n**Note**: When writing code for the module, do not utilize aliases; instead, write the module's complete path.\n\n```elixir\ndefmodule AllowedParentCustomDomain do\n  use GuardedStruct\n  @module_path \"MishkaDeveloperToolsTest.GuardedStructTest.AllowedParentCustomDomain\"\n\n  guardedstruct authorized_fields: true do\n    field(:username, String.t(),\n      domain: \"!auth.action=Custom[#{@module_path}, is_stuff?]\",\n      derive: \"validate(string)\"\n    )\n\n    sub_field(:auth, struct(), authorized_fields: true) do\n      field(:action, String.t(), derive: \"validate(not_empty)\")\n    end\n  end\n\n  def is_stuff?(data) when data == \"ok\", do: true\n  def is_stuff?(_data), do: false\nend\n```\n\n**Note**: if you want to use `custom` inside `derive` validation, you should do like this:\n\n```elixir\ndefmodule TestCustomValidationDerive do\n  use GuardedStruct\n\n  guardedstruct authorized_fields: true do\n    field(:status, String.t(), derive: \"validate(custom=[#{__MODULE__}, is_stuff?])\")\n  end\n\n  def is_stuff?(data) when data == \"ok\", do: true\n  def is_stuff?(_data), do: false\nend\n```\n\n**Note**: You can see when you use it inside a derive, the GuardedStruct calculates the you module `alias`.\n\n21. ##","ref":"GuardedStruct.html#guardedstruct/2-domain-core-key-with-custom-function-support"},{"type":"macro","title":"Conditional fields - GuardedStruct.guardedstruct/2","doc":"One of the unique capabilities of this macro is the ability to define conditions\nand differentiate between the various kinds of `fields`. Assume that you want the `social`\nfield to be able to take both a value `string` and a `map` where `address` and `provider`\nare included in the `map`.\nIt is important to notice that the `conditional_field` contained within this macro have\nthe capability of supporting `sub_field`. You can look at some illustrations down below.\n\nNote: Please read this if you want to document any conditional fields for your API.\nFor instance, your front team ought to be aware of which area of the output is for.\nYou have the option of adding the `hint` keyword in accordance with the aforementioned code.\nAnd the clue is in your practice here.\n\n**Output of hint**: `__hint__`\n\n```elixir\ndefmodule ConditionalFieldComplexTest do\n  use GuardedStruct\n  alias ConditionalFieldValidatorTestValidators, as: VAL\n\n  guardedstruct do\n    field(:provider, String.t())\n\n    sub_field(:profile, struct()) do\n      field(:name, String.t(), enforce: true)\n      field(:family, String.t(), enforce: true)\n\n      conditional_field(:address, any()) do\n        field(:address, String.t(), hint: \"address1\", validator: {VAL, :is_string_data})\n\n        sub_field(:address, struct(), hint: \"address2\", validator: {VAL, :is_map_data}) do\n          field(:location, String.t(), enforce: true)\n          field(:text_location, String.t(), enforce: true)\n        end\n\n        sub_field(:address, struct(), hint: \"address3\", validator: {VAL, :is_map_data}) do\n          field(:location, String.t(), enforce: true, derive: \"validate(string, location)\")\n          field(:text_location, String.t(), enforce: true)\n          field(:email, String.t(), enforce: true)\n        end\n      end\n    end\n\n    conditional_field(:product, any()) do\n      field(:product, String.t(), hint: \"product1\", validator: {VAL, :is_string_data})\n\n      sub_field(:product, struct(), hint: \"product2\", validator: {VAL, :is_map_data}) do\n        field(:name, String.t(), enforce: true)\n        field(:price, integer(), enforce: true)\n\n        sub_field(:information, struct()) do\n          field(:creator, String.t(), enforce: true)\n          field(:company, String.t(), enforce: true)\n\n          conditional_field(:inventory, integer() | struct(), enforce: true) do\n            field(:inventory, integer(),\n              hint: \"inventory1\",\n              validator: {VAL, :is_int_data},\n              derive: \"validate(integer, max_len=33)\"\n            )\n\n            sub_field(:inventory, struct(), hint: \"inventory2\", validator: {VAL, :is_map_data}) do\n              field(:count, integer(), enforce: true)\n              field(:expiration, integer(), enforce: true)\n            end\n          end\n        end\n      end\n    end\n  end\nend\n```\n\nCall the builder\n\n```elixir\nConditionalFieldComplexTest.builder(%{\n  provider: \"Mishka\",\n  profile: %{\n    name: \"Shahryar\",\n    family: \"Tavakkoli\",\n    address: %{\n      location: \"geo:48.198634,-16.371648,3.4;crs=wgs84;u=40.0\",\n      text_location: \"Nowhere\",\n      email: \"shahryar@mishka.group\"\n    }\n  },\n  product: %{\n    name: \"MishkaDeveloperTools\",\n    price: 0,\n    information: %{\n      creator: \"Shahryar Tavakkoli\",\n      company: \"mishka group\",\n      inventory: %{\n        count: 3_000_000,\n        expiration: 33\n      }\n    }\n  }\n})\n```\n\n22. ##","ref":"GuardedStruct.html#guardedstruct/2-conditional-fields"},{"type":"macro","title":"List Conditional fields - GuardedStruct.guardedstruct/2","doc":"The `conditional_fields` is one of the most important aspects of this macro, which is available\nto the programmer in all of its many variants. Typically, you have the ability to send a map\nthrough the `builder`. If the map is compliant with one of the requirements, your output will be returned.\nAdditionally, you have the ability to transmit the value of one of the keys related to the map in the form of a list.\nNow, with this option, you are able to transmit the complete entry as a list.\nIn addition, you are able to send one of the items on this list as another list,\nand nesting functionality has been made available to you.\n\n```elixir\nconditional_field(:activities, any(), structs: true) do\n  field(:activities, struct(), struct: ExtrenalConditional, validator: {VAL, :is_map_data}, hint: \"activities1\")\n\n  field(:activities, struct(), structs: ExtrenalConditional, validator: {VAL, :is_list_data}, hint: \"activities2\")\n\n  field(:activities, String.t(), hint: \"activities3\", validator: {VAL, :is_string_data})\nend\n```\nAs you can see in the code above, you only need to give the macro the `structs: true` option\n\n###","ref":"GuardedStruct.html#guardedstruct/2-list-conditional-fields"},{"type":"macro","title":"Note: - GuardedStruct.guardedstruct/2","doc":"> Using a list `conditional_field` in a nested list can create a logical bug for you if the list is not flattened, **Please test your builder before releasing to production**.","ref":"GuardedStruct.html#guardedstruct/2-note"},{"type":"function","title":"GuardedStruct.reduce_success_data_and_error_data/1","doc":"","ref":"GuardedStruct.html#reduce_success_data_and_error_data/1"},{"type":"extras","title":"Mishka Elixir Developer Tools","doc":"# Mishka Elixir Developer Tools\n\nWe tried to deliver a series of our client's [**CMS**](https://github.com/mishka-group/mishka-cms) built on [**Elixir**](https://elixir-lang.org/) at the start of the [**Mishka Group**](https://github.com/mishka-group) project, but we recently archived this open-source project and have yet to make plans to rework and expand it. This system was created using [**Phoenix**](https://www.phoenixframework.org/) and [**Phoenix LiveView**](https://hexdocs.pm/phoenix_live_view/Phoenix.LiveView.html). After a long period, a series of macros and functional modules emerged from this project and our other projects, which we are gradually publishing in this library.\n\n> **NOTICE**: Do not use the master branch; this library is under heavy development. Expect version `0.1.3`, and for using the new features, please wait until a new release is out.\n\n---\n\n- #### [GuardedStruct](https://github.com/mishka-group/mishka_developer_tools/blob/master/guidance/guarded-struct.md)\n\n- #### [Basic CRUD](https://github.com/mishka-group/mishka_developer_tools/blob/master/guidance/crud.md)\n\n- #### [PermissionAccess](https://github.com/mishka-group/mishka_developer_tools/blob/master/guidance/permission-access.md)\n\n---\n\n> Mishka developer tools provides some macros and modules to make creating your elixir application as easy as possible","ref":"readme.html"},{"type":"extras","title":"Installation - Mishka Elixir Developer Tools","doc":"The package can be installed by adding `mishka_developer_tools` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:mishka_developer_tools, \"~> 0.1.3\"}\n  ]\nend\n```\n\nThe docs can be found at [https://hexdocs.pm/mishka_developer_tools](https://hexdocs.pm/mishka_developer_tools).\n\n\n---\n# Donate\n\nIf the project was useful for you, the only way you can donate to me is the following ways\n\n| **BTC**                           | **ETH**                           | **DOGE**                          | **TRX**                           |\n| ----------------------------------| --------------------------------- | --------------------------------- | --------------------------------- |\n|  |  | | |\n\n \n   Donate addresses \n  \n  **BTC**:‌\n  ```\n  bc1q24pmrpn8v9dddgpg3vw9nld6hl9n5dkw5zkf2c\n  ```\n\n  **ETH**:\n  ```\n  0xD99feB9db83245dE8B9D23052aa8e62feedE764D\n  ```\n\n  **DOGE**:\n  ```\n  DGGT5PfoQsbz3H77sdJ1msfqzfV63Q3nyH\n  ```\n\n  **TRX**: \n  ```\n  TBamHas3wAxSEvtBcWKuT3zphckZo88puz\n  ```","ref":"readme.html#installation"}],"content_type":"text/markdown"}